//+-----------------------------------------------------------+
//| MT4 CUSTOM INDICATOR                       123Alarms.MQ4  |
//| copy to [experts\\indicators] and recompile or restart MT4 |
//+-----------------------------------------------------------+
//| Free software for personal non-commercial use only.       |
//| No guarantees are expressed or implied.                   |
//| Feedback welcome via Forex Factory private message.       |
//+-----------------------------------------------------------+
#property copyright "Copyright  2010 Robert Dee"
#property link      "www.forexfactory.com/robdee"

#define INDICATOR_VERSION    20101110       // VERSION 1
#define INDICATOR_NAME       "123Alarms"
#define RELEASE_LEVEL        "Public"
#define MT4_BUILD            226

#property indicator_chart_window

extern string IndicatorName  = "123PatternsV6";  // name of custom indicator to use for price alarms
extern string AlarmSound     = "symbol";         // WAV files must be in MT4\\sounds folder, set to "symbol" to use audusd.wav etc.
extern int    AlarmRepeat    = 6;                // number of times to repeat the sound
extern int    AlarmDelay     = 10;               // delay in seconds before repeating the sound
extern bool   AlarmPopup     = True;             // true means popup is enable, pops once per alarm

int      alarmcount;
double   alarmprice;
datetime alarmtime, lastsoundtime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
if(AlarmSound == "symbol") AlarmSound = Symbol()+".wav";
} // end of init()

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
double upperline = iCustom(NULL,0,IndicatorName,0,3); // use upperline value from previous closed candle
double lowerline = iCustom(NULL,0,IndicatorName,1,3); // use lowerline value from previous closed candle

if(Time[1] != alarmtime && upperline != alarmprice && lowerline != alarmprice) alarmcount = 0; // reset the alarm

while(Open[0] < upperline && High[0] > upperline)
   {
   // popups
   if(AlarmPopup == True && alarmprice != upperline) {Alert(Symbol()+" breaking upperline at "+DoubleToStr(upperline,Digits)); alarmprice = upperline;}
   // sounds
   if(alarmcount >= AlarmRepeat) break;                 // do no more
   if(TimeCurrent() < lastsoundtime+AlarmDelay) break;  // do no more
   PlaySound(AlarmSound);
   lastsoundtime = TimeCurrent();
   alarmtime = Time[1];
   alarmcount++;
   break;
   }

while(Open[0] > lowerline && Low[0] < lowerline)
   {
   // popups
   if(AlarmPopup == True && alarmprice != lowerline) {Alert(Symbol()+" breaking lowerline at "+DoubleToStr(lowerline,Digits)); alarmprice = lowerline;}
   // sounds
   if(alarmcount >= AlarmRepeat) break;                 // do no more
   if(TimeCurrent() < lastsoundtime+AlarmDelay) break;  // do no more
   PlaySound(AlarmSound);
   lastsoundtime = TimeCurrent();
   alarmtime = Time[1];
   alarmcount++;
   break;
   }

}// end of start()

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
}// end of deinit()


